/// <reference types="node" />
import http from 'http';
import { AffiliationWrite } from '../model/affiliationWrite';
import { AffiliationWritePatch } from '../model/affiliationWritePatch';
import { WrappedAffiliation } from '../model/wrappedAffiliation';
import { WrappedWithMetaArrayAffiliation } from '../model/wrappedWithMetaArrayAffiliation';
import { Authentication, Interceptor } from '../model/models';
import { OAuth } from '../model/models';
export declare enum AffiliationsApiApiKeys {
}
export declare class AffiliationsApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        default: Authentication;
        ClientCredentials: OAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    set useQuerystring(value: boolean);
    set basePath(basePath: string);
    set defaultHeaders(defaultHeaders: any);
    get defaultHeaders(): any;
    get basePath(): string;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: AffiliationsApiApiKeys, value: string): void;
    set accessToken(token: string);
    addInterceptor(interceptor: Interceptor): void;
    createAffiliation(affiliation: AffiliationWrite, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedAffiliation;
    }>;
    findAffiliations(limit?: number, offset?: number, page?: number, filter?: string, fields?: string, sort?: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedWithMetaArrayAffiliation;
    }>;
    getAffiliation(id: string, fields?: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedAffiliation;
    }>;
    patchAffiliation(id: string, affiliation: AffiliationWritePatch, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedAffiliation;
    }>;
    removeAffiliation(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedAffiliation;
    }>;
}
