import { Options } from 'request';
import { ClientCredentials } from 'simple-oauth2';
import { OAuth } from '../model/models';
export interface AuthConfig {
    client_id: string;
    client_secret: string;
    audience: string;
    token_host: string;
    token_path: string;
    scopes: string;
    custom_options?: Record<string, string>;
}
export declare class Auth extends OAuth {
    audience: string;
    scopes: string;
    clientCredentialsAuth: ClientCredentials;
    customOptions: Record<string, string> | undefined;
    constructor(config: AuthConfig);
    getToken(): Promise<import("simple-oauth2").AccessToken>;
    applyToRequest(requestOptions: Options): Promise<void>;
    private isAccessTokenValid;
}
