"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Auth = void 0;
var jwt_decode_1 = __importDefault(require("jwt-decode"));
var simple_oauth2_1 = require("simple-oauth2");
var models_1 = require("../model/models");
var Auth = (function (_super) {
    __extends(Auth, _super);
    function Auth(config) {
        var _this = _super.call(this) || this;
        _this.audience = "";
        _this.scopes = "";
        _this.audience = config.audience;
        _this.scopes = config.scopes;
        _this.customOptions = config.custom_options;
        _this.clientCredentialsAuth = new simple_oauth2_1.ClientCredentials({
            client: {
                id: config.client_id,
                secret: config.client_secret
            },
            auth: {
                tokenHost: config.token_host,
                tokenPath: config.token_path
            },
        });
        return _this;
    }
    Auth.prototype.getToken = function () {
        return __awaiter(this, void 0, void 0, function () {
            var tokenConfig, tokenResult;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        tokenConfig = __assign({ scope: this.scopes, audience: this.audience }, this.customOptions);
                        return [4, this.clientCredentialsAuth.getToken(tokenConfig)];
                    case 1:
                        tokenResult = _a.sent();
                        if (typeof tokenResult.token.access_token === 'string') {
                            this.accessToken = tokenResult.token.access_token;
                        }
                        return [2, tokenResult];
                }
            });
        });
    };
    Auth.prototype.applyToRequest = function (requestOptions) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!!this.isAccessTokenValid()) return [3, 2];
                        return [4, this.getToken()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        _super.prototype.applyToRequest.call(this, requestOptions);
                        return [2];
                }
            });
        });
    };
    Auth.prototype.isAccessTokenValid = function () {
        if (this.accessToken == "")
            return false;
        var bufferMs = 1000;
        var maxValidUnixSeconds = (Date.now() - bufferMs) / 1000;
        var decoded = (0, jwt_decode_1.default)(this.accessToken);
        if (!decoded.exp)
            return false;
        if (decoded.exp <= maxValidUnixSeconds)
            return false;
        return true;
    };
    return Auth;
}(models_1.OAuth));
exports.Auth = Auth;
;
//# sourceMappingURL=auth.js.map