/// <reference types="node" />
import http from 'http';
import { ConsentWrite } from '../model/consentWrite';
import { ConsentWritePatch } from '../model/consentWritePatch';
import { WrappedConsent } from '../model/wrappedConsent';
import { WrappedWithMetaArrayConsent } from '../model/wrappedWithMetaArrayConsent';
import { Authentication, Interceptor } from '../model/models';
import { OAuth } from '../model/models';
export declare enum ConsentsApiApiKeys {
}
export declare class ConsentsApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        default: Authentication;
        ClientCredentials: OAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    set useQuerystring(value: boolean);
    set basePath(basePath: string);
    set defaultHeaders(defaultHeaders: any);
    get defaultHeaders(): any;
    get basePath(): string;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: ConsentsApiApiKeys, value: string): void;
    set accessToken(token: string);
    addInterceptor(interceptor: Interceptor): void;
    createConsent(consent: ConsentWrite, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedConsent;
    }>;
    findConsents(limit?: number, offset?: number, page?: number, filter?: string, fields?: string, sort?: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedWithMetaArrayConsent;
    }>;
    getConsent(id: string, fields?: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedConsent;
    }>;
    patchConsent(id: string, consent: ConsentWritePatch, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedConsent;
    }>;
}
