/// <reference types="node" />
import http from 'http';
import { CountryWrite } from '../model/countryWrite';
import { CountryWritePatch } from '../model/countryWritePatch';
import { WrappedCountry } from '../model/wrappedCountry';
import { WrappedWithMetaArrayCountry } from '../model/wrappedWithMetaArrayCountry';
import { Authentication, Interceptor } from '../model/models';
import { OAuth } from '../model/models';
export declare enum CountriesApiApiKeys {
}
export declare class CountriesApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        default: Authentication;
        ClientCredentials: OAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    set useQuerystring(value: boolean);
    set basePath(basePath: string);
    set defaultHeaders(defaultHeaders: any);
    get defaultHeaders(): any;
    get basePath(): string;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: CountriesApiApiKeys, value: string): void;
    set accessToken(token: string);
    addInterceptor(interceptor: Interceptor): void;
    createCountry(id: string, country: CountryWrite, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedCountry;
    }>;
    findCountries(limit?: number, offset?: number, page?: number, filter?: string, fields?: string, sort?: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedWithMetaArrayCountry;
    }>;
    getCountry(id: string, fields?: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedCountry;
    }>;
    patchCountry(id: string, country: CountryWritePatch, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedCountry;
    }>;
}
