/// <reference types="node" />
import http from 'http';
import { OrgWrite } from '../model/orgWrite';
import { OrgWritePatch } from '../model/orgWritePatch';
import { WrappedOrg } from '../model/wrappedOrg';
import { WrappedWithMetaArrayOrg } from '../model/wrappedWithMetaArrayOrg';
import { Authentication, Interceptor } from '../model/models';
import { OAuth } from '../model/models';
export declare enum OrgsApiApiKeys {
}
export declare class OrgsApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        default: Authentication;
        ClientCredentials: OAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    set useQuerystring(value: boolean);
    set basePath(basePath: string);
    set defaultHeaders(defaultHeaders: any);
    get defaultHeaders(): any;
    get basePath(): string;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: OrgsApiApiKeys, value: string): void;
    set accessToken(token: string);
    addInterceptor(interceptor: Interceptor): void;
    createOrg(org: OrgWrite, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedOrg;
    }>;
    findOrgs(limit?: number, offset?: number, page?: number, filter?: string, fields?: string, sort?: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedWithMetaArrayOrg;
    }>;
    getOrg(id: string, fields?: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedOrg;
    }>;
    patchOrg(id: string, org: OrgWritePatch, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedOrg;
    }>;
}
