/// <reference types="node" />
import http from 'http';
import { PersonWrite } from '../model/personWrite';
import { PersonWritePatch } from '../model/personWritePatch';
import { WrappedPerson } from '../model/wrappedPerson';
import { WrappedWithMetaArrayPerson } from '../model/wrappedWithMetaArrayPerson';
import { Authentication, Interceptor } from '../model/models';
import { OAuth } from '../model/models';
export declare enum PersonsApiApiKeys {
}
export declare class PersonsApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        default: Authentication;
        ClientCredentials: OAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    set useQuerystring(value: boolean);
    set basePath(basePath: string);
    set defaultHeaders(defaultHeaders: any);
    get defaultHeaders(): any;
    get basePath(): string;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: PersonsApiApiKeys, value: string): void;
    set accessToken(token: string);
    addInterceptor(interceptor: Interceptor): void;
    createPersons(person: PersonWrite, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedPerson;
    }>;
    findPersons(limit?: number, offset?: number, page?: number, filter?: string, fields?: string, sort?: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedWithMetaArrayPerson;
    }>;
    getPerson(id: string, fields?: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedPerson;
    }>;
    patchPerson(id: string, person: PersonWritePatch, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedPerson;
    }>;
}
