/// <reference types="node" />
import http from 'http';
import { RelationWrite } from '../model/relationWrite';
import { RelationWritePatch } from '../model/relationWritePatch';
import { WrappedRelation } from '../model/wrappedRelation';
import { WrappedWithMetaArrayRelation } from '../model/wrappedWithMetaArrayRelation';
import { Authentication, Interceptor } from '../model/models';
import { OAuth } from '../model/models';
export declare enum RelationsApiApiKeys {
}
export declare class RelationsApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        default: Authentication;
        ClientCredentials: OAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    set useQuerystring(value: boolean);
    set basePath(basePath: string);
    set defaultHeaders(defaultHeaders: any);
    get defaultHeaders(): any;
    get basePath(): string;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: RelationsApiApiKeys, value: string): void;
    set accessToken(token: string);
    addInterceptor(interceptor: Interceptor): void;
    createRelation(relation: RelationWrite, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedRelation;
    }>;
    findRelations(limit?: number, offset?: number, page?: number, filter?: string, fields?: string, sort?: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedWithMetaArrayRelation;
    }>;
    getRelation(id: string, fields?: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedRelation;
    }>;
    patchRelation(id: string, relation: RelationWritePatch, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: WrappedRelation;
    }>;
}
